static const char rcsid[] = "$Id: capa.c,v 1.6 2000/08/23 11:05:19 jurekb Exp $";
/*
 *  Solid POP3 - a POP3 server
 *  Copyright (C) 1999  Jerzy Balamut <jurekb@dione.ids.pl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "includes.h"
#include "response.h"
#include "log.h"
#include "configfile.h"
#include "sktbuff.h"

#ifdef SPSASL
extern char sasl_mechanism[];
#endif
extern int allowuser;
extern int connection_state;

void c_print(char *name) {
	if (skt_write(name, strlen(name)) < 0) {
		pop_log(pop_priority, "capa: can't write to socket");
		pop_error("capa: write");
		exit(1);
	}
}

void print_capa(char *arg) {
#ifdef EXPIRATION
	long int tmp;
	char tmp2[100];
#endif

	send_ok("capability list follows");
	c_print("TOP\r\n");
	if (allowuser)
		c_print("USER\r\n");
#ifdef SPSASL
	if (allowsasl) {
		c_print("SASL ");
		c_print(sasl_mechanism);
		c_print("\r\n");
	}
#endif
	c_print("PIPELINING\r\n");
#ifdef EXPIRATION
# ifdef NONIPVIRTUALS
	if ((!rexp.enabled) && (!unrexp.enabled))
		c_print("EXPIRE NEVER USER\r\n");
# else
	if ((!rexp.enabled) && (!unrexp.enabled))
		c_print("EXPIRE NEVER\r\n");
# endif /* NONIPVIRTUALS */
	else {
		tmp = (rexp.enabled ? rexp.expperiod: unrexp.expperiod);
		if ((unrexp.enabled) && (unrexp.expperiod < tmp))
			tmp = unrexp.expperiod;
# ifdef NONIPVIRTUALS
		if (connection_state == AUTH_STATE)
			snprintf(tmp2, sizeof(tmp2), "EXPIRE %ld USER\r\n",
				 tmp / (24*60*60));
		else
			snprintf(tmp2, sizeof(tmp2), "EXPIRE %ld\r\n",
				 tmp / (24*60*60));
# else
		snprintf(tmp2, sizeof(tmp2), "EXPIRE %ld\r\n",
			tmp / (24*60*60));
# endif /* NONIPVIRTUALS */
		c_print(tmp2);
	}
#endif /* EXPIRATION */
	c_print("UIDL\r\n");
#ifdef SPTLS
	if (allowtls)
		c_print("STLS\r\n");
#endif
	c_print(".\r\n");
}
