static const char rcsid[] = "$Id: mapping.c,v 1.7 2000/09/16 22:06:01 jurekb Exp $";
/*
 *  Solid POP3 - a POP3 server
 *  Copyright (C) 1999  Jerzy Balamut <jurekb@dione.ids.pl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "includes.h"
#include "mapping.h"
#include "fdfgets.h"
#include "log.h"
#include "mydbm.h"
#include "utils.h"
#include <fcntl.h>
#include <pwd.h>
#ifdef HAVE_GRP_H
# include <grp.h>
#endif

/* result should be a (MAXARGLN+1)-byte buffer */
int map_finduser(char *mapfile, char *username, char *result) {
	int c;
	MYDBM db;
	char tmpbuf[MAXARGLN + sizeof(unsigned long int) + 1];
	char *act = tmpbuf;
	int resultsize = sizeof(tmpbuf) - 1;
	unsigned long int length;
	
	if (mydbm_open(&db, mapfile, DB_READER) < 0)
		return -1;
	c = mydbm_fetch(&db, username, tmpbuf, &resultsize);
	mydbm_close(&db);
	if ((c < 0) || (resultsize < sizeof(unsigned long int)))
		return -1;
	length = *((unsigned long int *) act);
	resultsize -= sizeof(unsigned long int);
	act += sizeof(unsigned long int);
	if ((length != resultsize) || (length > MAXARGLN))
		return -1;
	act[length] = 0;
	strcpy(result, act);
	return 0;
}

/* result should be a (MAXARGLN+1)-byte buffer */
int map_find_preauth_mapping(char *preauth_map_format, char *result) {

	if (strlen(preauth_map_format) >= (MAXARGLN + 1)) { /* impossible */
		pop_log(pop_priority, "mapping: weird error - contact author "
			"of program!!!");
		exit(1);
	}
	strcpy(result, preauth_map_format);
	if (expand_dir(result, NULL, MAXARGLN + 1) < 0) {
		pop_log(pop_priority, "mapping: error while expanding "
			"preauth_map_format");
		return -1;
	}
	return 0;
}
