/* $Id: mydbm.h,v 1.2 2000/08/23 11:05:19 jurekb Exp $ */
/*
 *  Solid POP3 - a POP3 server
 *  Copyright (C) 1999  Jerzy Balamut <jurekb@dione.ids.pl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _MYDBM_H
# define _MYDBM_H

# include "includes.h"

# ifdef GDBM
#  include <gdbm.h>
# else /* GDBM */
#  ifdef HAVE_NDBM_H
#   include <ndbm.h>
#  else /* HAVE_NDBM_H */
#   ifdef HAVE_DBM_H
#    include <dbm.h>
#   endif /* HAVE_DBM_H */
#  endif /* HAVE_NDBM_H */
# endif /* GDBM */

# ifdef GDBM
typedef GDBM_FILE MYDBM;
# else
typedef DBM *MYDBM;
# endif

# define DB_READER 0
# define DB_WRITER 1
# define DB_CREAT 2
# define DB_NEWDB 3

int mydbm_open(MYDBM *db, char *filename, int mode);
void mydbm_close(MYDBM *db);
int mydbm_fetch(MYDBM *db, char *key, char *value, int *valuesize);
int mydbm_exists(MYDBM *db, char *key);
int mydbm_delete(MYDBM *db, char *key);
int mydbm_store(MYDBM *db, char *key, char *value, int valuesize, int replace);
int mydbm_firstentry(MYDBM *db, char *key, int keylength, char *value,
	int *valuelength);
int mydbm_nextentry(MYDBM *db, char *key, int keylength, char *value,
	int *valuelength);

#endif /* mydbm.h */
