/* $Id: utils.h,v 1.7 2000/09/16 22:06:01 jurekb Exp $ */
/*
 *  Solid POP3 - a POP3 server
 *  Copyright (C) 1999  Jerzy Balamut <jurekb@dione.ids.pl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _UTILS_H
# define _UTILS_H

# include "includes.h"

int expand_dir(char *dir, char *homedir, size_t maxlength);
ssize_t write_loop(int fd, void *abuf, size_t acount);
int write_string(int fd, char *abuf);
ssize_t read_loop(int fd, void *abuf, size_t acount);
int read_string(int fd, char *abuf, size_t acount);
int set_privileges(uid_t auid, gid_t agid);
void after_authentication(int success, char *add_username);
# ifdef APOP
void after_apop(int success, char *add_username);
# endif
# ifdef SPSASL
void after_sasl(int success, char *add_username);
# endif

typedef enum {AUTH_USER, AUTH_APOP, AUTH_SASL} auth_method_t;

# ifdef MAPPING
void write_general_auth(auth_method_t method, char *username, char *password,
	char *mapname);
# else
void write_general_auth(auth_method_t method, char *username, char *password);
# endif
void read_general_auth(void);

void write_auth_error(void);

void write_logpriority(void);
void read_logpriority(void);
#endif /* utils.h */
